Attribute VB_Name = "Module1"
Option Explicit
Public DeviceType As String
Public PortNumber As Integer
Public Direction As Integer
Public currTime As Long ' in milliseconds
Public startTime As Single ' realtime clock
Public fadeLength As Long ' fade time in milliseconds
Public prevScene As String
Public blackout As Boolean
Public numChannels As Integer
Public Unsaved As Boolean
Public UnsavedPatch As Boolean
Public numChanChanged As Boolean
Public patchdata(1 To 512) As Integer
Public dmxdata(1 To 512) As Byte
Public deviceInitialized As Boolean
Public currentShowFile As String
Public currentPatchName As String
Public hackCount As Integer

' declare HTML help function
Declare Function HtmlHelp Lib "hhctrl.ocx" Alias _
    "HtmlHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, _
    ByVal wCommand As Long, ByVal dwData As String) As Long
Private Const HH_CLOSE_ALL = &H12
Global Const HH_DISPLAY_TOC = &H1 ' the Help table of contents
Global Const HH_DISPLAY_TOPIC = &H0
      Const HH_SET_WIN_TYPE = &H4
      Const HH_GET_WIN_TYPE = &H5
      Const HH_GET_WIN_HANDLE = &H6
      Const HH_DISPLAY_TEXT_POPUP = &HE   ' Display string resource ID or
                                          ' text in a pop-up window.
      Const HH_HELP_CONTEXT = &HF         ' Display mapped numeric value in
                                          ' dwData.
      Const HH_TP_HELP_CONTEXTMENU = &H10 ' Text pop-up help, similar to
                                          ' WinHelp's HELP_CONTEXTMENU.
      Const HH_TP_HELP_WM_HELP = &H11     ' text pop-up help, similar to
                                          ' WinHelp's HELP_WM_HELP.

Public Sub sendDMXdata()
' send dmx data using the correct function for the current device type
Select Case DeviceType
Case "OpenDMXUSB"
    OpenDmx.set_dmx dmxdata()
     ' don't send for this as it is sent every 50 ms anyway
    'OpenDmx.send
Case "DMXUSBpro"
    sendDMXpro
End Select
End Sub
Public Sub startDMX()
Dim a As Integer
' initialize the dmx device using the correct function for the current device type
Select Case DeviceType
Case "OpenDMXUSB"
    OpenDmx.init
    ' start Artnet timer (send DMX every 100 MS
    frmMain.DMXtimer.Enabled = True
Case "DMXUSBpro"
    initPro
End Select

' disable ArtNet for now, until it is tested
If ArtEnabled Then
    'Call ArtNet_Init
    'start artnet timer
    'frmMain.DMXtimer.Enabled = True
End If
' clear the universe - or better, load first scene
For a = 1 To 512
   dmxdata(a) = 0
Next a
'    sendDMXdata ' don't blackout
End Sub
Public Sub closeDMX()
' close the dmx device using the correct function for the current device type
Select Case DeviceType
Case "OpenDMXUSB"
    OpenDmx.done
Case "DMXUSBpro"
    closePro
End Select
End Sub
Public Sub loadShow(currentshowname As String)
Dim response, showName, savedDate, aLabel, scene, fadeRate, level, sceneName As String
Dim i, chan, numChan As Integer
' read a .shw file into memory (the cuelist)
If Unsaved = True Then
    response = MsgBox("Save changes first?", vbYesNo)
    If response = vbYes Then Call frmMain.mnuSaveShow_Click
End If
On Error GoTo Error
Open currentshowname For Input As 1
Input #1, showName, savedDate, numChan

If numChannels < numChan Then
   MsgBox "Can't load this show, it requires " & Str(numChan) & " fader channels (see Menu Settings)"
   Close 1
   Exit Sub
End If
'If numChanChanged = False Then numChannels = Numchan
' erase the cuelist
 frmCueList.MSFlexGrid1.Clear
 frmCueList.labelGrid
 frmCueList.MSFlexGrid1.Row = 1
 ' set captions
frmCueList.lblShowName = showName
frmCueList.lblDate = savedDate
frmCueList.Caption = "Cue Listing: " & showName & " saved: " & savedDate
' read in channel labels
For i = 0 To (numChan - 1)
Input #1, aLabel
frmMain.txtChanLabel(i) = aLabel
Next i
' read in cues -- load them into the grid
frmCueList.MSFlexGrid1.Visible = False 'hide grid while loading
While Not EOF(1)
    Input #1, scene
    frmCueList.MSFlexGrid1.Col = 0
    frmCueList.MSFlexGrid1.Text = scene
    Input #1, fadeRate
    frmCueList.MSFlexGrid1.Col = 1
    frmCueList.MSFlexGrid1.Text = fadeRate
    For chan = 0 To numChan - 1
        Input #1, level
        frmCueList.MSFlexGrid1.Col = 3 + chan
        frmCueList.MSFlexGrid1.Text = level
    Next chan
    Input #1, sceneName
    frmCueList.MSFlexGrid1.Col = 2
    frmCueList.MSFlexGrid1.Text = sceneName
    frmCueList.MSFlexGrid1.AddItem " ", 1
Wend
Close 1
'sort all rows
frmCueList.MSFlexGrid1.RowSel = frmCueList.MSFlexGrid1.Row
frmCueList.MSFlexGrid1.Col = 0 ' sort by column 0
frmCueList.MSFlexGrid1.Sort = flexSortNumericAscending
'if row 1 is blank, delete it
frmCueList.MSFlexGrid1.Row = 1
If frmCueList.MSFlexGrid1.Text = " " Then frmCueList.MSFlexGrid1.RemoveItem 1
frmCueList.MSFlexGrid1.Visible = True

' load the first scene into the A bank
frmCueList.MSFlexGrid1.Col = 0
frmCueList.MSFlexGrid1.Row = 1
loadSceneA (frmCueList.MSFlexGrid1.Text)
'load the second cue into the B bank
frmCueList.MSFlexGrid1.Col = 0
frmCueList.MSFlexGrid1.Row = 2
loadSceneB (frmCueList.MSFlexGrid1.Text)

currentShowFile = currentshowname
Exit Sub
Error:
MsgBox "Can't load " & currentshowname & " Error: " & Str(Err)
Close 1
frmCueList.MSFlexGrid1.Visible = True
End Sub
Public Sub saveShow(saveshowname)
Dim savedDate As String
Dim i, r, chan As Integer

' write the show data to a .shw file
Open saveshowname For Output As 1
savedDate = Date & " " & Time
Write #1, frmCueList.lblShowName, savedDate, numChannels
' save channel labels
For i = 0 To numChannels - 2
    Write #1, frmMain.txtChanLabel(i),
Next i
Write #1, frmMain.txtChanLabel(numChannels - 1)
' save each cue
For r = 1 To frmCueList.MSFlexGrid1.Rows - 1
    frmCueList.MSFlexGrid1.Row = r
    frmCueList.MSFlexGrid1.Col = 0
    Write #1, frmCueList.MSFlexGrid1.Text, ' cue number
    frmCueList.MSFlexGrid1.Col = 1
    Write #1, frmCueList.MSFlexGrid1.Text, ' faderate
    For chan = 0 To numChannels - 1
        frmCueList.MSFlexGrid1.Col = 3 + chan
        Write #1, frmCueList.MSFlexGrid1.Text, ' channel level
    Next chan
    frmCueList.MSFlexGrid1.Col = 2
    Write #1, frmCueList.MSFlexGrid1.Text ' scene name
Next r
Close 1
Unsaved = False
frmCueList.Caption = "Cue Listing: " & frmCueList.lblShowName & " saved: " & savedDate
End Sub

Public Function findCueRow(cue As String) As Integer
Dim i As Integer
cue = Trim(cue)
' search through all the grid rows (column zero)to find the row the cue is on
frmCueList.MSFlexGrid1.Col = 0
For i = 1 To frmCueList.MSFlexGrid1.Rows - 1
    frmCueList.MSFlexGrid1.Row = i
    If frmCueList.MSFlexGrid1.Text = cue Then
        findCueRow = i
        Exit Function
    End If
Next i
findCueRow = -1 ' can't find that cue
End Function
Sub loadSceneA(cue As String)

Dim i, thisCue As Integer
cue = Trim(cue)
If Len(cue) = 0 Then Exit Sub
thisCue = findCueRow(cue)
'If thisCue < 0 Then thisCue = 1 ' cue not found, load cue number 1
If thisCue < 0 Then Exit Sub ' cue not found, do nothing
frmCueList.MSFlexGrid1.Row = thisCue
frmCueList.MSFlexGrid1.Col = 1
frmRun.txtRate = frmCueList.MSFlexGrid1.Text
frmCueList.MSFlexGrid1.Col = 2
frmRun.lblSceneNameA.Caption = frmCueList.MSFlexGrid1.Text
frmCueList.MSFlexGrid1.Col = 0
frmRun.lblSceneA = frmCueList.MSFlexGrid1.Text
For i = 0 To numChannels - 1
    frmCueList.MSFlexGrid1.Col = 3 + i
    frmMain.SliderChan(i).Value = 100 - val(frmCueList.MSFlexGrid1.Text)
Next i
frmCueList.Label1 = "Cue " & cue & " Loaded into Scene A"
frmCueList.MSFlexGrid1.Col = 0
frmCueList.MSFlexGrid1.CellBackColor = RGB(200, 255, 255)
End Sub
Sub loadSceneB(cue As String)
Dim i, thisCue As Integer
cue = Trim(cue)
If Len(cue) = 0 Then Exit Sub
thisCue = findCueRow(cue)
'If thisCue < 0 Then thisCue = 1 ' cue not found, load cue number 1
If thisCue < 0 Then Exit Sub ' cue not found, do nothing
frmCueList.MSFlexGrid1.Row = thisCue
frmCueList.MSFlexGrid1.Col = 1
frmRun.txtRate = frmCueList.MSFlexGrid1.Text
frmCueList.MSFlexGrid1.Col = 2
frmRun.lblSceneNameB.Caption = frmCueList.MSFlexGrid1.Text
frmCueList.MSFlexGrid1.Col = 0
frmRun.lblSceneB = frmCueList.MSFlexGrid1.Text
For i = 0 To numChannels - 1
    frmCueList.MSFlexGrid1.Col = 3 + i
    frmMain.SliderChan(i + numChannels).Value = 100 - val(frmCueList.MSFlexGrid1.Text)
Next i
frmCueList.Label1 = "Cue " & cue & " Loaded into Scene B"
frmCueList.MSFlexGrid1.Col = 0
frmCueList.MSFlexGrid1.CellBackColor = RGB(200, 255, 255)
End Sub

Public Sub setNumChannels()
Dim num As String
num = InputBox("Number of channels to control (number of sliders) -- Warning cues may be erased!", "Number of channels", numChannels)
If val(num) > 0 Or val(num) <= 512 Then
   numChannels = val(num)
   NewNumChannels
End If
End Sub
Public Sub NewNumChannels()
   numChanChanged = True
   Unload frmMain
   Unload OutputMonitor
   Unload frmCueList
   Load frmMain
   frmMain.Show
   Load OutputMonitor
   Load frmCueList
   'frmCueList.Show
End Sub
Public Sub loadPatch(currentshowname As String)
Dim response, patchName, savedDate, dmx, fader As String
Dim i As Integer
' read a .patch file into memory (the softpatch)
If UnsavedPatch = True Then
    response = MsgBox("Save changes first?", vbYesNo)
    If response = vbYes Then Call frmPatch.mnuSavePatch_Click
End If

On Error GoTo Error
Open currentshowname For Input As 1
' erase the patchlist
 frmPatch.MSFlexGrid1.Clear
frmPatch.MSFlexGrid1.Rows = 2
frmPatch.MSFlexGrid1.Cols = 2
 'frmPatch.labelPatchGrid
 'frmPatch.MSFlexGrid1.Row = 1
 frmPatch.MSFlexGrid1.Visible = False ' hide grid while loading it
 ' load patch data
Input #1, patchName, savedDate
' read in patch -- load them into the grid
While Not EOF(1)
    Input #1, dmx
    frmPatch.MSFlexGrid1.Col = 0
    frmPatch.MSFlexGrid1.Text = dmx
    Input #1, fader
    frmPatch.MSFlexGrid1.Col = 1
    frmPatch.MSFlexGrid1.Text = fader
    frmPatch.MSFlexGrid1.AddItem " ", 1
Wend
Close 1
'sort all rows
frmPatch.MSFlexGrid1.RowSel = frmPatch.MSFlexGrid1.Row
frmPatch.MSFlexGrid1.Col = 0 ' sort by column 0
frmPatch.MSFlexGrid1.Sort = flexSortNumericAscending
'if row 1 is blank, delete it
frmPatch.MSFlexGrid1.Row = 1
If frmPatch.MSFlexGrid1.Text = " " Then frmPatch.MSFlexGrid1.RemoveItem 1
frmPatch.labelColumns
' set captions
frmPatch.MSFlexGrid1.Visible = True
currentPatchName = patchName
frmPatch.lblPatchName = currentPatchName
frmPatch.Caption = "SoftPatch"
frmPatch.lblDate = savedDate

For i = 1 To 512 ' load the patch into the global patchdata array
    patchdata(i) = val(frmPatch.MSFlexGrid1.TextMatrix(i, 1))
Next i
Exit Sub
Error:
MsgBox "Can't load " & currentshowname
frmPatch.MSFlexGrid1.Visible = True
End Sub
Public Sub savePatch(saveshowname)
Dim savedDate As String
Dim r As Integer
' write the patch data to a .patch file
Open saveshowname For Output As 1
savedDate = Date & " " & Time
Write #1, frmPatch.lblPatchName, savedDate
' save each cue
For r = 1 To frmPatch.MSFlexGrid1.Rows - 1
    frmPatch.MSFlexGrid1.Row = r
    frmPatch.MSFlexGrid1.Col = 0
    Write #1, frmPatch.MSFlexGrid1.Text, ' DMX dimmer number
    frmPatch.MSFlexGrid1.Col = 1
    Write #1, frmPatch.MSFlexGrid1.Text, ' console fader number
Next r
Close 1
UnsavedPatch = False
End Sub

Public Sub saveScene(scene As String, sceneNum As String, Optional rate As String = "", Optional sceneName As String = "")

' record a scene as a cue
 ' scene must be A or B
 ' sceneNum is a decimal number in a string
 ' rate is a decimal number in a string
 Dim i As Integer
 Dim aLevel As String
Dim thisCue As Integer ' the row number of the spreadsheet the cue is stored in
    thisCue = findCueRow(Trim(sceneNum)) ' does the cue number not exist?
    If thisCue < 0 Then ' not in the spreadsheet, create a new cue
        If rate = "" Then rate = "2" ' default rate of 2 sec
        frmCueList.MSFlexGrid1.AddItem Trim(sceneNum) & vbTab & rate & vbTab & sceneName, 1
        frmCueList.MSFlexGrid1.Row = 1
    Else ' update existing cue
        frmCueList.MSFlexGrid1.Row = thisCue
        frmCueList.MSFlexGrid1.Col = 1
        If rate <> "" Then frmCueList.MSFlexGrid1.Text = rate 'update only if given a value
        frmCueList.MSFlexGrid1.Col = 2
        If sceneName <> "" Then frmCueList.MSFlexGrid1.Text = sceneName 'update only if given a value
    End If
    ' record the levels for each fader
    For i = 0 To (numChannels - 1)
            frmCueList.MSFlexGrid1.Col = 3 + i
            Select Case scene
            Case "A"
                aLevel = Trim(Str(100 - frmMain.SliderChan(i).Value))
            Case "B"
                aLevel = Trim(Str(100 - frmMain.SliderChan(i + numChannels).Value))
            End Select
            frmCueList.MSFlexGrid1.Text = aLevel
    Next i
    frmCueList.MSFlexGrid1.RowSel = frmCueList.MSFlexGrid1.Row ' sort all rows
    frmCueList.MSFlexGrid1.Col = 0 'sort on column 0
    frmCueList.MSFlexGrid1.Sort = flexSortNumericAscending
    Unsaved = True
End Sub
